//$Id: ResourceServiceImpl.java 2008-8-3 下午06:06:51 chaostone Exp $
/*
 *
 * Copyright c 2005-2009
 * Licensed under the Apache License, Version 2.0 (the "License")
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * 
 */
/********************************************************************************
 * @author chaostone
 * 
 * MODIFICATION DESCRIPTION
 * 
 * Name           Date          Description 
 * ============   ============  ============
 * chaostone      2008-8-3  Created
 *  
 ********************************************************************************/
package org.beangle.security.internal.service;

import java.util.List;

import org.beangle.model.persist.impl.BaseServiceImpl;
import org.beangle.model.query.builder.OqlBuilder;
import org.beangle.security.Resource;
import org.beangle.security.service.ResourceService;

public class ResourceServiceImpl extends BaseServiceImpl implements ResourceService {

	@SuppressWarnings("unchecked")
	public void updateState(Long[] resourceIds, boolean isEnabled) {
		OqlBuilder query = OqlBuilder.from(Resource.class, "resource");
		query.where("resource.id in (:ids)", resourceIds);
		List<Resource> resources = entityDao.search(query);
		for (Resource resource : resources) {
			resource.setEnabled(isEnabled);
		}
		entityDao.saveOrUpdate(resources);
	}

	public Resource getResource(String name) {
		OqlBuilder<Resource> query = OqlBuilder.from(Resource.class, "resource");
		query.where("resource.name=:name", name);
		query.cacheable();
		List<Resource> resources = entityDao.search(query);
		if (resources.isEmpty()) {
			return null;
		} else {
			return resources.get(0);
		}
	}

	@SuppressWarnings("unchecked")
	public List<Resource> getResources(int scope) {
		OqlBuilder query = OqlBuilder.from(Resource.class, "resource");
		query.where("resource.scope=:scope and resource.enabled=true", new Integer(scope));
		return entityDao.search(query);
	}

	@SuppressWarnings("unchecked")
	public List<Resource> getResources() {
		OqlBuilder query = OqlBuilder.from(Resource.class, "resource");
		query.where("resource.enabled=true");
		return entityDao.search(query);
	}

}
