//$Id: RestrictionService.java,v 1.1 2007-10-14 下午04:41:01 chaostone Exp $
/*
 *
 * Copyright c 2005-2009
 * Licensed under the Apache License, Version 2.0 (the "License")
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * 
 */
/********************************************************************************
 * @author chaostone
 * 
 * MODIFICATION DESCRIPTION
 * 
 * Name                 Date                Description 
 * ============         ============        ============
 * chaostone              2007-10-14         Created
 *  
 ********************************************************************************/

package org.beangle.security.restriction.service;

import java.util.Collection;
import java.util.List;
import java.util.Set;

import org.beangle.model.query.builder.OqlBuilder;
import org.beangle.security.Resource;
import org.beangle.security.User;
import org.beangle.security.restriction.Param;
import org.beangle.security.restriction.Pattern;
import org.beangle.security.restriction.Restriction;

/**
 * 资源访问约束服务
 * 
 * @author chaostone
 * 
 */
public interface RestrictionService {

	public List<Restriction> getRestrictions(User user, Resource resource);
	
	public List<Restriction> getAuthorityRestrictions(User user, Resource resource);
	
	public List<Object> getValues(Param param);

	/**
	 * 从总的集合中找出item中规定的集合
	 * 
	 * @param values
	 * @param item
	 * @return
	 */
	public <T> Set<T> select(Collection<T> values, Restriction res, Param param);

	/**
	 * 从总的集合中找出items中规定的集合的并集
	 * 
	 * @param values
	 * @param items
	 * @return
	 */
	public <T> Set<T> select(Collection<T> values, List<? extends Restriction> restrictions,
			Param param);

	public void apply(OqlBuilder<?> builder, Collection<? extends Pattern> patterns,
			Collection<? extends Restriction> restrictions);

	public void apply(OqlBuilder<?> builder, Pattern pattern, Restriction restriction);

	public void setRestrictionApply(RestrictionApply apply);

}
